<?php
/**
 * @version       $Id translationVm_categoryFilter.php 2012-06-19 13:50:00Z zanardi$
 * @author        GiBiLogic
 * @author        ZDJL505 user from the Joomfish forum
 * @description   this file introduce a filter by category in the product list
 *                of your JoomFish translation screen. You should also use a 
 *                modified vm_product.xml file to include the filter definition
 */                

class translationVm_categoryFilter extends translationFilter
{
	function translationVm_categoryFilter ($contentElement){
		$this->filterNullValue=-1;
		$this->filterType="vm_category";
		$this->filterField = $contentElement->getFilter("vm_category");
		parent::translationFilter($contentElement);
	}
	
	function _createFilter(){
		$db = JFactory::getDBO();
		if (!$this->filterField ) return "";
		$filter="";
		if ($this->filter_value!=$this->filterNullValue){
			// get list of product_id in the appropriate category
			$sql = "SELECT xref.product_id FROM #__vm_product_category_xref as xref"
			." WHERE xref.category_id=$this->filter_value";
			$db->setQuery($sql);
			$prodids = $db->loadObjectList();
			$idstring = "";
			foreach ($prodids as $pid){
				if (strlen($idstring)>0) $idstring.=",";
				$idstring.=$pid->product_id;
			}
			$filter = "c.product_id IN($idstring)";
		}
		return $filter;
	}
	
/**
 * Creates vm_category filter 
 *
 * @param unknown_type $filtertype
 * @param unknown_type $contentElement
 * @return unknown
 */
	function _createfilterHTML(){
		$db = JFactory::getDBO();

		if (!$this->filterField) return "";
		$categoryOptions=array();
		$categoryOptions[] = JHTML::_('select.option', '-1', JText::_('ALL CATEGORIES'));

		$sql = "SELECT DISTINCT cat.category_id, cat.category_name FROM #__vm_category as cat,"
			  ." #__".$this->tableName." as c, #__vm_product_category_xref as xref"
			  ." WHERE c.product_id=xref.product_id AND xref.".$this->filterField."=cat.category_id ORDER BY cat.category_name";
		$db->setQuery( $sql );
		$cats = $db->loadObjectList();
		$catcount=0;
		foreach($cats as $cat){
			$categoryOptions[] = JHTML::_('select.option', $cat->category_id,$cat->category_name);
			$catcount++;
		}
		$categoryList=array();
		$categoryList["title"]=JText::_('CATEGORY FILTER');
		$categoryList["html"] = JHTML::_('select.genericlist', $categoryOptions, 'vm_category_filter_value', 'class="inputbox" size="1" onchange="document.adminForm.submit();"', 'value', 'text', $this->filter_value );

		return $categoryList;
	}
}
